package com.sheep.gamegroup.view.activity;

import android.annotation.SuppressLint;
import android.content.Context;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.net.Uri;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.view.GestureDetector;
import android.view.MotionEvent;
import android.view.View;
import android.view.WindowManager;
import android.widget.MediaController;
import android.widget.VideoView;

import com.kfzs.duanduan.utils.StatusBarUtils;
import com.sheep.gamegroup.absBase.BaseActivity;
import com.sheep.gamegroup.util.DataUtil;
import com.sheep.gamegroup.util.LogUtil;
import com.sheep.jiuyan.samllsheep.R;
import com.sheep.jiuyan.samllsheep.utils.G;

import butterknife.BindView;

/**
 * Created by realicing on 2018/11/9.
 * realicing@sina.com
 * 视频播放
 */
public class ActPlayVideo extends BaseActivity implements MediaPlayer.OnInfoListener, MediaPlayer.OnPreparedListener, MediaPlayer.OnErrorListener, MediaPlayer.OnCompletionListener, View.OnLayoutChangeListener {

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        StatusBarUtils.setTranslucent(this);
        super.onCreate(savedInstanceState);
    }

    @BindView(R.id.videoView)
    VideoView videoView;
    @BindView(R.id.video_loading)
    View video_loading;

    @Override
    protected int getLayoutId() {
        return R.layout.act_play_video;
    }

    @Override
    public void initView() {
        initVolume();
        String url = DataUtil.getObject(getIntent(), String.class);
        Uri uri = Uri.parse(url);
        videoView.setOnInfoListener(this);
        videoView.setOnPreparedListener(this);
        videoView.setOnErrorListener(this);
        videoView.setOnCompletionListener(this);
        videoView.addOnLayoutChangeListener(this);
        videoView.setMediaController(new MediaController(this));
        videoView.setVideoURI(uri);
    }

    @SuppressLint("ClickableViewAccessibility")
    @Override
    public void initListener() {
        mGestureDetector = new GestureDetector(getApplicationContext(), mGestureListener);
        View.OnTouchListener listener = new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {
                return onTouchEvent(event);
            }
        };
        videoView.setOnTouchListener(listener);
    }
    private GestureDetector mGestureDetector;

    //播放或者暂停
    private void playOrPause() {
        if(videoView.isPlaying()){
            pause();
        } else {
            play();
        }
    }
    //播放
    private void play(){
        if(videoView == null){
            return;
        }
        videoView.start();
    }
    //暂停
    private void pause(){
        if(videoView == null){
            return;
        }
        videoView.pause();
    }
    //销毁
    private void destroy(){
        if(videoView == null){
            return;
        }
        videoView.stopPlayback();
    }


    @Override
    public boolean onTouchEvent(MotionEvent event) {
        return mGestureDetector.onTouchEvent(event);
    }

    @Override
    protected void onResume() {
        super.onResume();
        if(!isPauseByUser)
            play();
    }
    //是否是用户手机暂停
    private boolean isPauseByUser;
    @Override
    protected void onPause() {
        super.onPause();
        if(videoView != null && videoView.isPlaying())
            isPauseByUser = false;
        if(video_loading != null)
            video_loading.setVisibility(View.VISIBLE);
        pause();
    }

    @Override
    protected void onDestroy() {
        destroy();
        super.onDestroy();
        mAudioManager = null;
    }

//    //滑动方向
//    private int direction = 0;
//    //左右滑动
//    public static final int DIRECTION_LEFT_RIGHT = 1;
//    //上下滑动
//    public static final int DIRECTION_TOP_BOTTOM = 2;
    private GestureDetector.SimpleOnGestureListener mGestureListener = new GestureDetector.SimpleOnGestureListener() {
        @Override
        public boolean onDown(MotionEvent e) {
            LogUtil.println("mGestureListener", "onDown");
//            direction = 0;
            return super.onDown(e);
        }

        @Override
        public void onLongPress(MotionEvent e) {
            LogUtil.println("mGestureListener", "onLongPress");
            super.onLongPress(e);
        }

        @Override
        public boolean onSingleTapConfirmed(MotionEvent e) {
            LogUtil.println("mGestureListener", "onSingleTapConfirmed");
//            if(isPlaying)
//                isPauseByUser = true;
//            playOrPause();
            return super.onSingleTapConfirmed(e);
        }
        @Override
        public boolean onScroll(MotionEvent e1, MotionEvent e2,
                                float distanceX, float distanceY) {
            float mOldX = e1.getX(), mOldY = e1.getY();
            int y = (int) e2.getRawY();
            int windowWidth = ActPlayVideo.this.windowWidth;
            int windowHeight = ActPlayVideo.this.windowHeight;
            int lineMiddle = windowWidth / 2;
            if (mOldX > lineMiddle)// 左边滑动
                onBrightnessSlide((mOldY - y) / windowHeight);
            else if (mOldX < lineMiddle)// 右边滑动
                onVolumeSlide((mOldY - y) / windowHeight);
            return super.onScroll(e1, e2, distanceX, distanceY);
        }


//        @Override
//        public boolean onScroll(MotionEvent event1, MotionEvent event2, float distanceX, float distanceY) {
//            LogUtil.println("mGestureListener", distanceX, distanceY);
//            if (event1 == null || event2 == null) {
//                return super.onScroll(event1, event2, distanceX, distanceY);
//            }
//            if (direction == 0) {
//                float a = Math.abs(distanceY);
//                float b = Math.abs(distanceX);
//                if (a > b) {
//                    LogUtil.println("mGestureListener", "上下滑动");
//                    direction = DIRECTION_TOP_BOTTOM;
//                } else if (b > a) {
//                    LogUtil.println("mGestureListener", "左右滑动");
//                    direction = DIRECTION_LEFT_RIGHT;
//                }
//            }
//            return super.onScroll(event1, event2, distanceX, distanceY);
//        }
//
//        @Override
//        public boolean onFling(MotionEvent event1, MotionEvent event2, float velocityX, float velocityY) {
//            LogUtil.println("mGestureListener", velocityX, velocityY);
//            if (event1 == null || event2 == null) {
//                return super.onFling(event1, event2, velocityX, velocityY);
//            }
//            final int FLING_MIN_DISTANCE = 100, FLING_MIN_VELOCITY = 200;
//            if (event1.getX() - event2.getX() > FLING_MIN_DISTANCE
//                    && Math.abs(velocityX) > FLING_MIN_VELOCITY) {
//                // Fling left
//                LogUtil.println("mGestureListener", "Fling left");
//                //音量增益减
//            } else if (event2.getX() - event1.getX() > FLING_MIN_DISTANCE
//                    && Math.abs(velocityX) > FLING_MIN_VELOCITY) {
//                // Fling right
//                LogUtil.println("mGestureListener", "Fling rigth");
//                //音量增益加
//            } else if (event2.getY() - event1.getY() > FLING_MIN_DISTANCE
//                    && Math.abs(velocityY) > FLING_MIN_VELOCITY) {
//                if (direction == DIRECTION_LEFT_RIGHT) {
//                    // Fling down
//                    LogUtil.println("mGestureListener", "Fling down");
//                    //频道减
//                }
//            } else if (event1.getY() - event2.getY() > FLING_MIN_DISTANCE
//                    && Math.abs(velocityY) > FLING_MIN_VELOCITY) {
//                if (direction == DIRECTION_LEFT_RIGHT) {
//                    // Fling up
//                    LogUtil.println("mGestureListener", "Fling up");
//                    //频道加
//                }
//            }
////            return super.onFling(event1, event2, velocityX, velocityY);
//            return false;
//        }
    };
    private AudioManager mAudioManager;
    private int mMaxVolume;//最大音量
    private int mVolume;//当前音量
    private void initVolume(){
        mAudioManager = (AudioManager) getSystemService(Context.AUDIO_SERVICE);
        if(mAudioManager != null)
            mMaxVolume = mAudioManager.getStreamMaxVolume(AudioManager.STREAM_MUSIC);
    }
    //滑动改变音量
    private void onVolumeSlide(float percent) {
        if (mVolume == -1) {
            mVolume = mAudioManager.getStreamVolume(AudioManager.STREAM_MUSIC);
            if (mVolume < 0)
                mVolume = 0;

            // 显示
//                mOperationBg.setImageResource(R.drawable.video_volumn_bg);
//                mVolumeBrightnessLayout.setVisibility(View.VISIBLE);
        }

        int index = (int) (percent * mMaxVolume) + mVolume;
        if (index > mMaxVolume)
            index = mMaxVolume;
        else if (index < 0)
            index = 0;

        // 变更声音
        mAudioManager.setStreamVolume(AudioManager.STREAM_MUSIC, index, 0);
        // 变更进度条
//            ViewGroup.LayoutParams lp = mOperationPercent.getLayoutParams();
//            lp.width = findViewById(R.id.operation_full).getLayoutParams().width * index / mMaxVolume;
//            mOperationPercent.setLayoutParams(lp);
    }
    private float mBrightness = -1;
    //滑动改变亮度
    private void onBrightnessSlide(float percent) {
        if (mBrightness < 0) {
            mBrightness = getWindow().getAttributes().screenBrightness;
            if (mBrightness <= 0.00f)
                mBrightness = 0.50f;
            if (mBrightness < 0.01f)
                mBrightness = 0.01f;

            // 显示
//                mOperationBg.setImageResource(R.drawable.video_brightness_bg);
//                mVolumeBrightnessLayout.setVisibility(View.VISIBLE);
        }
        WindowManager.LayoutParams lpa = getWindow().getAttributes();
        lpa.screenBrightness = mBrightness + percent;
        if (lpa.screenBrightness > 1.0f)
            lpa.screenBrightness = 1.0f;
        else if (lpa.screenBrightness < 0.01f)
            lpa.screenBrightness = 0.01f;
        getWindow().setAttributes(lpa);

//            ViewGroup.LayoutParams lp = mOperationPercent.getLayoutParams();
//            lp.width = (int) (findViewById(R.id.operation_full).getLayoutParams().width * lpa.screenBrightness);
//            mOperationPercent.setLayoutParams(lp);
    }
    @Override
    public boolean onInfo(MediaPlayer mediaPlayer, int what, int extra) {
        LogUtil.println("ActPlayVideo", "onInfo what = " + what + " extra = " + extra);
        if (!mediaPlayer.isLooping())
            mediaPlayer.setLooping(true);
        switch (what) {
            case MediaPlayer.MEDIA_INFO_BUFFERING_START:
                LogUtil.println("ActPlayVideo", "onInfo", "正在缓冲");
                if(video_loading != null)
                    video_loading.setVisibility(View.VISIBLE);
                break;
            case MediaPlayer.MEDIA_INFO_BUFFERING_END:
            case MediaPlayer.MEDIA_INFO_VIDEO_RENDERING_START:
                LogUtil.println("ActPlayVideo", "onInfo", "缓冲完成");
                //缓存完成，继续播放
                if(video_loading != null)
                    video_loading.setVisibility(View.GONE);
                break;
        }
        return false;
    }
    @Override
    public void onPrepared(MediaPlayer mediaPlayer) {
        LogUtil.println("ActPlayVideo", "onPrepared");
        if(video_loading != null)
            video_loading.setVisibility(View.GONE);
    }

    @Override
    public boolean onError(MediaPlayer mediaPlayer, int what, int extra) {
        LogUtil.println("ActPlayVideo", "onInfo what = " + what + " extra = " + extra);
        return false;
    }

    @Override
    public void onCompletion(MediaPlayer mediaPlayer) {
        LogUtil.println("ActPlayVideo", "onCompletion");
    }

    private int windowWidth = G.WIDTH;
    private int windowHeight = G.HEIGHT;
    @Override
    public void onLayoutChange(View view, int left, int top, int right, int bottom, int oldLeft, int oldTop, int oldRight, int oldBottom) {
        LogUtil.println("ActPlayVideo", "onLayoutChange", left, top, right, bottom, oldLeft, oldTop, oldRight, oldBottom);
        this.windowWidth = left + right;
        this.windowHeight = top + bottom;
    }
}
